;****** MEMCPY32 ***********************************************
;***************************************************************
                ideal
                %crefref
                %noincl
                %nomacs
                p386

;		model	large
;               include "help.asi"
                include "386.asi"       ;for Flags_ZF
;               include "seg0.asi"
;               include "system.asi"



;###### CODE ###################################################
;               codeseg
        segment ASM_TEXT word public 'CODE'
                assume  cs:ASM_TEXT


;***************************************************************
;****** Sub:    _is_rm32
;***************************************************************
;****** Entry:  none
;****** Return: AX=1 - it is a 386+ in real mode
;******         AX=0 - otherwise
;****** Uses:   Flags
;***************************************************************
        global  _is_rm32:far
        proc    _is_rm32 far

;****** Check processor ****************************************
                push    sp
                pop     ax
                cmp     ax,sp
                jne     @@ret   ;ZF=0, it is a 86/186, not a 386+

                smsw    ax
                test    al,1	;MSW_PE
                jnz     @@ret   ;ZF=0, we're in PM/VM, not RM

                push    ds dx
                push    0
                pop     ds
                mov     ax,offset excp6
		mov	dx,cs
                pushf
                cli
                xchg    [06h*4  ],ax
                xchg    [06h*4+2],dx
               ;cmp     sp,sp           ;force ZF=1 - already done
                xchg    eax,eax         ;triggers excp6 on 286 - sets ZF=0
                mov     [06h*4  ],ax
                mov     [06h*4+2],dx
                popf
                pop     dx ds

;****** Return *************************************************
@@ret:          mov     ax,1    ;ZF=1 - AX=1
                jz      @@skip
                dec     ax      ;ZF=0 - AX=0
@@skip:         ret
        endp    _is_rm32


;***************************************************************
;****** Sub:    excp6
;***************************************************************
;****** Entry:  excp 6 trap
;****** Return: ZF=0; IP += 2;
;****** Uses:   None
;***************************************************************
        proc    excp6   far
oldFlags        =       (word bp+6)
oldCS           =       (word bp+4)
oldIP           =       (word bp+2)
oldBP           =       (word bp+0)

;****** Init ***************************************************
                push	bp
		mov	bp,sp

;****** Update stack *******************************************
                add     [oldIP],2
                and     [byte low oldFlags],not Flags_ZF

;****** Return *************************************************
@@ret:          pop	bp
                iret
        endp    excp6


;***************************************************************
;void memcpy32(u16 dstseg,u32 dstofs,u16 srcseg,u32 srcofs,u32 size);
;***************************************************************
;****** Uses:   Flags
;***************************************************************
        global  _memcpy32:far
        proc    _memcpy32 far

                arg     dstseg  :word,  \
                        dstofs  :dword, \
                        srcseg  :word,  \
                        srcofs  :dword, \
                        size    :dword  = PARAM_SIZE

                local   GDTR    :pword, \
                        oldGDTR :pword  = TEMP_SIZE

;****** Init ***************************************************
@@rm32:         enter   TEMP_SIZE,0
                push    es ds eax ecx esi edi
                sgdt    [oldGDTR]

;****** Load GDTR **********************************************
                mov     eax,cs          ;yes, it zero extends!
                shl     eax,4
                mov     cx,offset GDT   ;could be simple add eax,ofs GDT
                movzx   ecx,cx          ;but TLINK will moan...
                add     eax,ecx         ;
                mov     [word GDTR],0FFFFh      ;GDT limit
                mov     [dword GDTR+2],eax      ;GDT base
                lgdt    [GDTR]

;****** Go into PM *********************************************
                pushf   ;better than plain 'cli'
                cli     ;

                mov     eax,cr0
                or      al,01h          ;CR0_PE on
                mov     cr0,eax
                jmp     short $+2       ;*Required*!
                                        ;3+ NOPs also work fine (chkd on 386)
;****** Move data **********************************************
                mov     cx,0008h
                mov     ds,cx           ;base=0, lim = 4gb
                mov     es,cx           ;
                movzx   esi,[srcseg]
                shl     esi,4
                add     esi,[srcofs]
                movzx   edi,[dstseg]
                shl     edi,4
                add     edi,[dstofs]
                mov     ecx,[size]
                cld
                db      67h     ;address width override for esi/edi
                db      66h     ;operand width override for ecx
            rep movsb

;****** Return to RM *******************************************
                and     al,0feh         ;CR0_PE off
                mov     cr0,eax         ;ds/es limits are *not* reset to 64kb
                                        ;  but who cares :-)
                jmp     short $+2
                popf    ;restore IF - better than blind 'sti'!

;****** Return *************************************************
@@ret:          lgdt    [oldGDTR]
                pop     edi esi ecx eax ds es
                leave
                ret

;****** Const data *********************************************
                org     $-8     ;save 8 bytes
;selector 0000: unused
GDT             dd      ?,?

;selector 0008: Data seg [0,FFFFFFFF]
                ;       lim_lo              base_lo
                dw      1111111111111111b,  0000000000000000b
                db      00000000b,10010010b,10001111b,00000000b
                ;       base_med  PPlSEDWA  GD  l_hi  base_hi

        endp    _memcpy32

        ends    ASM_TEXT

        end

;###### END OF FILE ############################################
